## confetti 20120731

=== Makefile ===
CC=gcc
AR=ar
RANLIB=ranlib
LD=ld
BISON=bison -y -d 
FLEX=flex

ARFLAGS=rcv
LDFLAGS=-r
CFLAGS=-Wall -g -O0 -Werror -pedantic -std=gnu99
INCLUDE=-I.
LIB=

OBJS=confetti.o h_dump.o f_dump.o c_dump.o p_dump.o d_dump.o
PRSSRC = prscfl

all: confetti

ifdef PRSSRC
OBJS += $(PRSSRC:%=%_scan.o)
OBJS += $(PRSSRC:%=%_gram.o)

$(PRSSRC:%=%_scan.o): $(PRSSRC:%=%_gram.c)

$(PRSSRC:%=%_scan.c): $(PRSSRC:%=%.l)
	$(FLEX) -o$@ $<

$(PRSSRC:%=%_gram.c): $(PRSSRC:%=%.y)
	$(BISON) $<
	mv -f y.tab.c $@
	mv -f y.tab.h $(@:%.c=%.h)
endif

.SUFFIXES: .o.c

.c.o:
	$(CC) $(CFLAGS) $(INCLUDE) -c $<

confetti: $(OBJS)
	$(CC) -o $@ $(OBJS) $(LIB)

example: all
	$(MAKE) -C example -f Makefile all


p_dump.c: parse_source.c header_source.c

p_dump.o: p_dump.c parse_source.c header_source.c

parse_source.c: prscfg_gram.c prscfg_gram.h prscfg_scan.c
	cat prscfg_gram.h prscfg_gram.c prscfg_scan.c | \
		perl ./makec.pl \
	> $@

header_source.c: prscfg.h
	perl ./makec.pl < $< > $@

prscfg_scan.c: prscfg.l
	$(FLEX) -o$@ $<

prscfg_gram.c: prscfg.y
	$(BISON) $<
	mv -f y.tab.c $@
	mv -f y.tab.h $(@:%.c=%.h)

test: example
	@[ -d results ] || mkdir results
	@[ -d diffs ] || mkdir diffs
	@for FILE in dump default defcfg custom buffer ; do \
		printf "%-12s  ........ " $$FILE ; \
		if sh tests/$$FILE > results/$$FILE 2>results/$$FILE.errout && diff -c expected/$$FILE results/$$FILE > diffs/$$FILE ; then \
			echo ok ; \
		else \
			echo FAILED ; \
		fi ; \
	done

clean:
	rm -rf confetti $(OBJS)
	rm -rf *core y.tab.*
	rm -rf results diffs
ifdef PRSSRC
	for prs in $(PRSSRC); do rm -rf $${prs}_gram.c $${prs}_scan.c $${prs}_gram.h ; done
endif
	rm -f prscfg_gram.c prscfg_gram.h prscfg_scan.c parse_source.c header_source.c
	$(MAKE) -C example -f Makefile clean

=== example/Makefile ===
CONFETTI=../confetti
NAME=my_product
CFG=example.cfgtmpl

CC=gcc

CFLAGS=-Wall -g -O0 -Werror -std=gnu99
INCLUDE=-I.
LIB=

example_OBJS=example.o my_product_cfg.o prscfg.o 

example_buffer_OBJS=example_buffer.o my_product_cfg.o prscfg.o

all: $(NAME).cfg example example_buffer 

example.c: $(NAME)_cfg.h prscfg.h

example_buffer.c: $(NAME)_cfg.h prscfg.h

.SUFFIXES: .o.c

.c.o:
	$(CC) $(CFLAGS) $(INCLUDE) -c $<

example: $(example_OBJS)
	$(CC) -o $@ $(example_OBJS) $(LIB)

example_buffer: $(example_buffer_OBJS)
	$(CC) -o $@ $(example_buffer_OBJS) $(LIB)

$(NAME).cfg: $(CFG)
	$(CONFETTI) -i $< -n $(NAME) -f $@

$(NAME)_cfg.c: $(CFG)
	$(CONFETTI) -i $< -n $(NAME) -c $@

$(NAME)_cfg.h: $(CFG)
	$(CONFETTI) -i $< -n $(NAME) -h $@

prscfg.c: $(CFG)
	$(CONFETTI) -i $< -p $@

prscfg.h: $(CFG)
	$(CONFETTI) -i $< -H $@

prscfg.c: prscfg.h $(NAME)_cfg.h

$(NAME)_cfg.c: prscfg.h $(NAME)_cfg.h

clean:
	rm -f $(NAME).cfg $(NAME)_cfg.c $(NAME)_cfg.h
	rm -f prscfg.c prscfg.h
	rm -f $(example_OBJS) $(example_buffer_OBJS)
	rm -f example example_buffer *core

=== debian/changelog ===
confetti (20120731-1) unstable; urgency=low

  * Initial release. (Closes: #683485)

 -- Dmitry E. Oboukhov <unera@debian.org>  Tue, 31 Jul 2012 16:32:27 +0400

=== debian/control ===
Source: confetti
Section: devel
Priority: optional
Maintainer: Dmitry E. Oboukhov <unera@debian.org>
Build-Depends: cdbs, debhelper, bison, flex, dpkg-dev (>= 1.16.1~)
Standards-Version: 3.9.3
Homepage: https://github.com/mailru/confetti

Package: confetti
Depends: ${shlibs:Depends}, ${misc:Depends}
Architecture: any
Description: configuration file parser generator
 The utility generates C-code by config template.
 The code parses Your application config file and creates
 C-structures that can be used by Your program.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

package	 := $(shell dpkg-parsechangelog|grep ^Source  | awk '{print $$2}')
version	 := $(shell dpkg-parsechangelog|grep ^Version | awk '{print $$2}')
uversion := $(shell echo $(version)|sed 's/-[[:digit:]]\+$$//')



build/confetti::
	make
	make test
	pod2man --section=1 \
		--center='configuration file parser generator' \
		--name=confetti \
		debian/confetti.pod > confetti.1

clean::
	make clean
	rm -f confetti.1

tarball: clean
	cd .. && tar \
		--exclude=.git \
		--exclude=debian \
		-czvf $(package)_$(uversion).orig.tar.gz $(package)-$(uversion)
